Subject: Re: Zero not allowed

From: "Rosen, Brian" <[email-masked]>
Date: Fri, 2 Feb 2001 09:02:42 -0500

Please explain if Annex C is only used with Binary encoding,
and SDP is not allowed in LocalControl, how Annex C can be used in
LocalControl.

Brian

> -----Original Message-----
> From: Christian Groves [mailto:[email-masked]]
> Sent: Friday, February 02, 2001 1:14 AM
> To: Rosen, Brian
> Cc: [email-masked]
> Subject: Re: Zero not allowed
>
>
> G'Day Brian,
>
> Quite easily annex C is really a package if you look at the ASN1. Text
> specifying Annex C for local control added to the approved
> implementors
> guide. Annex C from the start was applicable for local, remote and
> control.
>
> Cheers, Christian
>
> "Rosen, Brian" wrote:
> >
> > I don't understand how Annex C can be used with Local
> unless a package
> > happens to define a property that has the same value as an Annex C
> > property.  Anything in Local has to be defined in a package.
> >
> >    The LocalControl Descriptor contains the Mode property, the
> >    ReserveGroup and ReserveValue properties and properties of a
> >    termination (defined in Packages) that are stream
> specific, and are
> >    of interest between the MG and the MGC.  Values of
> properties may be
> >
> > Brian
> >
> > > -----Original Message-----
> > > From: Christian Groves [mailto:[email-masked]]
> > > Sent: Wednesday, January 31, 2001 9:33 PM
> > > To: [email-masked]
> > > Subject: Re: Zero not allowed
> > >
> > >
> > > G'Day Troy,
> > >
> > > I didn't say that every element is is valid for all three. I
> > > said Annex
> > > C is appropriate for all 3. As you point out, something
> > > that's used for
> > > LocalControl probably isn't valid for Local/Remote.
> > >
> > > Annex C.11 SDP equivalents could be used in Local Control
> if you want.
> > > As defined in ABNF H.248 Annex B, SDP cannot be used in
> Local Control
> > > :).
> > >
> > > Annex C is there to be used how you want its a bucket the
> same way SDP
> > > is. To make any sense of it I maintain that you need extra
> > > documentation
> > > ie. profiles, capability sets Q.1950 to figure out the appropriate
> > > information elements to drive things for certain
> > > procedures/functionality. Otherwise H.248, annex a, b, c,
> packages etc
> > > is a mess and interoperability for real applications is a mess.
> > >
> > > Cheers, Christian
> > >
> > > Troy Cauble wrote:
> > > >
> > > > Christian,
> > > >
> > > > Are you saying that every Annex C property is appropriate for
> > > > all three of the Local, Remote, and LocalControl descriptors?
> > > >
> > > > I suspect they're not and that each Annex C property should
> > > > identify which descriptors they're appropriate for.  (Package
> > > > properties do this.)
> > > >
> > > > What about Annex C.11, the SDP equivalents?  Are they
> appropriate
> > > > for local control or not?  You say "yes" and "no" below :)
> > > >
> > > > -troy
> > > >
> > > > Christian Groves wrote:
> > > > >
> > > > > Just to clarify Tom, both SDP and Annex C ARE within
> > > local and remote.
> > > > > Annex C is also for Local Control. SDP is not.
> > > > >
> > > > > Christian
> > > > >
> > > > > Tom Taylor wrote:
> > > > > >
> > > > > > Just as a historical sidelight: originally we were
> > > going to allow both SDP and Annex C encodings within Local
> > > and Remote, but
> > > > > > the use of Annex C got restricted to binary encoding at
> > > the Redbank meeting.  Can x00 not appear within an MTPAddress, in
> > > > > > which case the exclusion is unwarranted?
> > > > > >
> > > > > > I'm also concerned about the assumption of
> > > null-terminated strings.  That assumption is C/C++ specific
> > > and should not be
> > > > > > refelcted in a general protocol.  Not that we should
> > > deliberately make it hard for C programmers, but we shouldn't
> > > do anything
> > > > > > unnatural just to accommodate them.
> > > > > >
> > > > > > On Tue, 16 Jan 2001 11:26:03 -0500, Troy Cauble
> > > <[email-masked]> wrote:
> > > > > >
> > > > > > >Yes.  Please don't add the zero.
> > > > > > >
> > > > > > >SDP is limited to "the ISO 10646 character set in
> > > > > > >UTF-8 encoding".
> > > > > > >
> > > > > > >Based on that the range of characters for "octetString"
> > > > > > >should probably be narrowed, not widened.
> > > > > > >
> > > > > > >I think the problem is that the name "octetString" is
> > > > > > >misleading and implies that a full range of octet values
> > > > > > >needs to be supported.
> > > > > > >
> > > > > > >I'm especially worried about adding '0' because that
> > > > > > >terminates a character string and may cause implementation
> > > > > > >issues.
> > > > > > >
> > > > > > >-troy
> > > > > > >
> > > > > > >
> > > > > > >"Rosen, Brian" wrote:
> > > > > > >>
> > > > > > >> Well, maybe something along the lines of
> > > > > > >> "The octet zero is not among the permitted
> > > characters in octet string,
> > > > > > >> which is used in the ABNF for local and remote
> > > descriptors.  As the current
> > > > > > >> definition of these descriptors is limited to SDP,
> > > and a zero octet would
> > > > > > >> not
> > > > > > >> be a legal character in SDP, this is not a concern."
> > > > > > >>
> > > > > > >> > -----Original Message-----
> > > > > > >> > From: Christian Groves
> > > [mailto:[email-masked]]
> > > > > > >> > Sent: Monday, January 15, 2001 12:45 AM
> > > > > > >> > To: [email-masked]
> > > > > > >> > Subject: Re: Zero not allowed
> > > > > > >> >
> > > > > > >> >
> > > > > > >> > G'Day Brian and Paul,
> > > > > > >> >
> > > > > > >> > It doesn't sound like people care very much for
> > > this change?
> > > > > > >> > Do you want
> > > > > > >> > something added to the implementors' guide.
> > > > > > >> >
> > > > > > >> > Cheers, Christian
> > > > > > >> >
> > > > > > >> > Paul Long wrote:
> > > > > > >> > >
> > > > > > >> > > Brian,
> > > > > > >> > >
> > > > > > >> > > The low end of the range of acceptable
> > > characters for octetString
> > > > > > >> > > suspiciously starts with %01 rather than %00.
> > > > > > >> > >
> > > > > > >> > >    octetString          = *(nonEscapeChar)
> > > > > > >> > >    nonEscapeChar        = ( "\}" / %x01-7C /
> %x7E-FF )
> > > > > > >> > >
> > > > > > >> > > Since octetString is only referenced in mtpAddress,
> > > > > > >> > localDescriptor, and
> > > > > > >> > > remoteDescriptor, maybe it doesn't matter if
> an octet of
> > > > > > >> > zero is excluded. I
> > > > > > >> > > was just wondering why it was left out.
> Sounds like there
> > > > > > >> > was no reason.
> > > > > > >> > >
> > > > > > >> > > Paul
> > > > > > >> > >
> > > > > > >> > > -----Original Message-----
> > > > > > >> > > From: Media Gateway Control (megaco)
> > > > > > >> > >
[mailto:[email-masked]]On Behalf Of
> > > > > >> > Rosen, Brian
> > > > > >> > > Sent: Friday, January 12, 2001 2:08 PM
> > > > > >> > > To: [email-masked]
> > > > > >> > > Subject: Re: Zero not allowed
> > > > > >> > >
> > > > > >> > > I don't think we thought about it.
> > > > > >> > > For SDP, it doesn't matter.  Beyond that, who knows.
> > > > > >> > > I suppose it would be better if it allowed zero.
> > > > > >> > >
> > > > > >> > > Brian
> > > > > >> > >
> > > > > >> > > > -----Original Message-----
> > > > > >> > > > From: Paul Long [mailto:[email-masked]]
> > > > > >> > > > Sent: Sunday, December 31, 2000 12:30 PM
> > > > > >> > > > To: [email-masked]
> > > > > >> > > > Subject: Zero not allowed
> > > > > >> > > >
> > > > > >> > > >
> > > > > >> > > > I noticed that an octet of zero is not allowed
> > in the ABNF
> > > > > >> > > > octetString. Was
> > > > > >> > > > this intentional?
> > > > > >> > > >
> > > > > >> > > > Paul Long
> > > > > >> > > > ipDialog, Inc.
> > > > > >> >
> >